## libksieve 24.12.3

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
set(PIM_VERSION "6.3.3")

project(libksieve VERSION ${PIM_VERSION})

set(KF_MIN_VERSION "6.6.0")
set(QT_REQUIRED_VERSION "6.7.0")
find_package(ECM ${KF_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(GenerateExportHeader)
include(ECMGenerateHeaders)

include(ECMSetupVersion)
include(FeatureSummary)
include(KDEGitCommitHooks)
include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES
src/*.cpp
src/*.h
autotests/*.cpp
autotests/*.h
)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(ECMFeatureSummary)
include(ECMAddTests)
include(ECMAddQch)
include(ECMCheckOutboundLicense)
file(GLOB_RECURSE ALL_SOURCE_FILES
src/*.cpp
src/*.h
autotests/*.cpp
autotests/*.h
)
ecm_check_outbound_license(LICENSES GPL-2.0-only  FILES ${ALL_SOURCE_FILES})

set(KTEXTADDONS_MIN_VERSION "1.5.4")

option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")

set(LIBKSIEVE_LIB_VERSION ${PIM_VERSION})
set(KMIME_LIB_VERSION "6.3.3")
set(IDENTITYMANAGEMENT_LIB_VERSION "6.3.3")
set(KMAILTRANSPORT_LIB_VERSION "6.3.3")
set(KPIMTEXTEDIT_LIB_VERSION "6.3.3")
set(LIBKDEPIM_LIB_VERSION "6.3.3")
set(PIMCOMMON_LIB_VERSION "6.3.3")
set(KIMAP_LIB_VERSION "6.3.3")

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if(USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
endif()
add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
option(KDEPIM_ENTERPRISE_BUILD "Enable features specific to the enterprise branch, which are normally disabled. Also, it disables many components not needed for Kontact such as the Kolab client." FALSE)
# Look for Sasl2 before anything else
find_package(Sasl2)
set_package_properties(Sasl2 PROPERTIES TYPE REQUIRED)

find_package(Qt6 ${QT_REQUIRED_VERSION} CONFIG REQUIRED Widgets PrintSupport WebEngineWidgets)
find_package(KF6I18n ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6ColorScheme ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6KIO ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6CoreAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6IconThemes ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KPim6PimCommon ${PIMCOMMON_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6Libkdepim ${LIBKDEPIM_LIB_VERSION} CONFIG REQUIRED)
find_package(KF6NewStuff ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Archive ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6SyntaxHighlighting ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Sonnet ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KPim6Mime ${KMIME_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6IdentityManagementCore ${IDENTITYMANAGEMENT_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MailTransport ${KMAILTRANSPORT_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6IMAP ${KIMAP_LIB_VERSION} CONFIG REQUIRED)

find_package(KF6TextEditTextToSpeech ${KTEXTADDONS_MIN_VERSION} CONFIG)
if(TARGET KF6::TextEditTextToSpeech)
    add_definitions(-DHAVE_KTEXTADDONS_TEXT_TO_SPEECH_SUPPORT)
endif()
find_package(KF6TextCustomEditor ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6TextAddonsWidgets ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6TextUtils ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6DocTools ${KF_MIN_VERSION})
set_package_properties(KF6DocTools PROPERTIES DESCRIPTION
    "Tools to generate documentation"
    TYPE OPTIONAL
)


add_definitions(-DDONT_HAVE_TEXT_TO_SPEACH_SUPPORT)



########### Targets ###########


ecm_set_disabled_deprecation_versions(QT 6.8.0 KF 6.8.0)


if(BUILD_TESTING)
    add_definitions(-DBUILD_TESTING)
endif()
########### CMake Config Files ###########
if(BUILD_TESTING)
    find_package(Qt6 ${QT_REQUIRED_VERSION} CONFIG REQUIRED COMPONENTS Test)
    add_subdirectory(autotests)
endif()

add_subdirectory(src)

ecm_qt_install_logging_categories(
        EXPORT LIBKSIEVE
        FILE libksieve.categories
        DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
        )

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

ki18n_install(po)
if(KF6DocTools_FOUND)
    kdoctools_install(po)
endif()

ecm_feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

ecm_add_tests(lexertest.cpp parsertest.cpp  NAME_PREFIX "libksieve-parser-" LINK_LIBRARIES KPim6::KSieve Qt::Test)

=== src/ksieve/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023-2024 Laurent Montel <montel.org>
# SPDX-License-Identifier: BSD-3-Clause

ecm_setup_version(PROJECT VARIABLE_PREFIX LIBKSIEVE
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/libksieve_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveConfigVersion.cmake"
                        SOVERSION 6
)

add_library(KPim6KSieve)
add_library(KPim6::KSieve ALIAS KPim6KSieve)

target_sources(KPim6KSieve PRIVATE
    utf8validator.cpp
    utf8validator.h
    lexer.cpp
    lexer_p.h
    lexer.h
    parser.cpp
    parser.h
    parser_p.h
    error.cpp
    error.h
)
if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(KPim6KSieve PROPERTIES UNITY_BUILD ON)
endif()
generate_export_header(KPim6KSieve BASE_NAME ksieve)

target_link_libraries(KPim6KSieve
    PRIVATE
    Qt::Core KF6::I18n
)

set_target_properties(KPim6KSieve PROPERTIES
    VERSION ${LIBKSIEVE_VERSION}
    SOVERSION ${LIBKSIEVE_SOVERSION}
    EXPORT_NAME KSieve
)


set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KPim6KSieve")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KPimKSieveConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveConfig.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT KPim6KSieveTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KPim6KSieveTargets.cmake NAMESPACE KPim6::)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libksieve_version.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KPim6/KSieve COMPONENT Devel
)

target_include_directories(KPim6KSieve PUBLIC "$<BUILD_INTERFACE:${libksieve_SOURCE_DIR}/src;${libksieve_BINARY_DIR}/src>")
install(TARGETS KPim6KSieve EXPORT KPim6KSieveTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== src/ksievecore/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023-2024 Laurent Montel <montel.org>
# SPDX-License-Identifier: BSD-3-Clause

ecm_setup_version(PROJECT VARIABLE_PREFIX LIBKSIEVECORE
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/libksievecore_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveCoreConfigVersion.cmake"
                        SOVERSION 6
)

add_library(KPim6KSieveCore)
add_library(KPim6::KSieveCore ALIAS KPim6KSieveCore)

target_sources(KPim6KSieveCore PRIVATE
    sieveimapinstance/sieveimapinstance.cpp
    sieveimapinstance/sieveimapinstance.h
    sieveimapinstance/sieveimapinstanceinterface.cpp
    sieveimapinstance/sieveimapinstanceinterface.h
    sieveimapinstance/sieveimapinstanceinterfacemanager.cpp
    sieveimapinstance/sieveimapinstanceinterfacemanager.h
)

target_sources(KPim6KSieveCore PRIVATE
    managescriptsjob/checkkolabkep14supportjob.cpp
    managescriptsjob/checkkolabkep14supportjob.h
    managescriptsjob/generateglobalscriptjob.cpp
    managescriptsjob/generateglobalscriptjob.h
    managescriptsjob/parseuserscriptjob.cpp
    managescriptsjob/parseuserscriptjob.h
    managescriptsjob/renamescriptjob.cpp
    managescriptsjob/renamescriptjob.h
    managescriptsjob/checkscriptjob.cpp
    managescriptsjob/checkscriptjob.h
)

target_sources(KPim6KSieveCore PRIVATE
    util/util.cpp
    util/util.h
    util/abstractakonadiimapsettinginterface.cpp
    util/abstractakonadiimapsettinginterface.h
    util/akonadiimapsettinginterface.cpp
    util/akonadiimapsettinginterface.h
    util/sieveimapaccountsettings.cpp
    util/sieveimapaccountsettings.h
    util/findaccountinfojob.cpp
    util/findaccountinfojob.h
    util/sieveimappasswordprovider.cpp
    util/sieveimappasswordprovider.h
)

target_sources(KPim6KSieveCore PRIVATE
    scriptsparsing/xmlprintingscriptbuilder.cpp
    scriptsparsing/xmlprintingscriptbuilder.h
    scriptsparsing/parsingutil.cpp
    scriptsparsing/parsingutil.h
)

target_sources(KPim6KSieveCore PRIVATE
    vacation/vacationhelperjob.cpp
    vacation/vacationhelperjob.h
    vacation/vacationscriptextractor.cpp
    vacation/vacationscriptextractor.h
    vacation/vacationutils.cpp
    vacation/vacationutils.h
    vacation/vacationcreatescriptjob.cpp
    vacation/vacationcreatescriptjob.h
    vacation/vacationcheckjob.cpp
    vacation/vacationcheckjob.h
    vacation/searchserverwithvacationsupportjob.cpp
    vacation/searchserverwithvacationsupportjob.h
    vacation/multiimapvacationmanager.h
    vacation/multiimapvacationmanager.cpp
)

ecm_qt_declare_logging_category(KPim6KSieveCore HEADER libksievecore_debug.h IDENTIFIER LIBKSIEVECORE_LOG CATEGORY_NAME org.kde.pim.libksieve.core
    DESCRIPTION "kdepim (libksievecore)"
    EXPORT LIBKSIEVE
)
kconfig_add_kcfg_files(KPim6KSieveCore settings/sieve-vacation.kcfgc)


target_link_libraries(KPim6KSieveCore
    PUBLIC
    Qt::Core
    KPim6::KManageSieve
    KPim6::KSieve
    PRIVATE
    KPim6::PimCommon
    KF6::I18n
    KF6::CoreAddons
    KPim6::MailTransport
    KPim6::Mime
    KPim6::IdentityManagementCore
)

generate_export_header(KPim6KSieveCore BASE_NAME ksievecore)
if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(KPim6KSieveCore PROPERTIES UNITY_BUILD ON)
endif()


set_target_properties(KPim6KSieveCore PROPERTIES
    VERSION ${LIBKSIEVECORE_VERSION}
    SOVERSION ${LIBKSIEVECORE_SOVERSION}
    EXPORT_NAME KSieveCore
)

target_include_directories(KPim6KSieveCore
    INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KPim6/KSieveCore/;${KDE_INSTALL_INCLUDEDIR}/KPim6/KSieveCore>")
target_include_directories(KPim6KSieveCore PUBLIC "$<BUILD_INTERFACE:${libksieve_SOURCE_DIR}/src/ksievecore;${libksieve_BINARY_DIR}/src/ksievecore>")

if(BUILD_TESTING)
    add_subdirectory(sieveimapinstance/autotests)
    add_subdirectory(managescriptsjob/autotests)
    add_subdirectory(util/autotests/)
    add_subdirectory(scriptsparsing/autotests)
    add_subdirectory(vacation/autotests)
endif()

ecm_generate_headers(ksievecore_Camelcaseimapinstance_HEADERS
    HEADER_NAMES
    SieveImapInstance
    SieveImapInstanceInterface
    SieveImapInstanceInterfaceManager
    REQUIRED_HEADERS ksievecore_imapinstance_HEADERS
    PREFIX KSieveCore
    RELATIVE sieveimapinstance
)

ecm_generate_headers(ksievecore_Camelmanagescriptsjob_HEADERS
    HEADER_NAMES
    RenameScriptJob
    CheckScriptJob
    REQUIRED_HEADERS ksievecore_managescriptsjob_HEADERS
    PREFIX KSieveCore
    RELATIVE managescriptsjob
)

ecm_generate_headers(ksievecore_Camelcaseutil_HEADERS
    HEADER_NAMES
    Util
    SieveImapAccountSettings
    SieveImapPasswordProvider
    REQUIRED_HEADERS ksievecore_util_HEADERS
    PREFIX KSieveCore
    RELATIVE util
)

ecm_generate_headers(ksievecore_Camelcasescriptsparsing_HEADERS
    HEADER_NAMES
    XMLPrintingScriptBuilder
    ParsingUtil
    REQUIRED_HEADERS ksievecore_scriptsparsing_HEADERS
    PREFIX KSieveCore
    RELATIVE scriptsparsing
)

ecm_generate_headers(ksievecore_Camelcasevacation_HEADERS
    HEADER_NAMES
    SearchServerWithVacationSupportJob
    VacationUtils
    VacationCreateScriptJob
    VacationCheckJob
    MultiImapVacationManager
    REQUIRED_HEADERS ksievecore_vacation_HEADERS
    PREFIX KSieveCore
    RELATIVE vacation
)

install(TARGETS KPim6KSieveCore EXPORT KPim6KSieveCoreTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
    ${ksievecore_Camelcaseimapinstance_HEADERS}
    ${ksievecore_Camelmanagescriptsjob_HEADERS}
    ${ksievecore_Camelcaseutil_HEADERS}
    ${ksievecore_Camelcasescriptsparsing_HEADERS}
    ${ksievecore_Camelcasevacation_HEADERS}

    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KPim6/KSieveCore/KSieveCore
    COMPONENT Devel
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/ksievecore_export.h
    ${ksievecore_imapinstance_HEADERS}
    ${ksievecore_managescriptsjob_HEADERS}
    ${ksievecore_util_HEADERS}
    ${ksievecore_scriptsparsing_HEADERS}
    ${ksievecore_vacation_HEADERS}

    ${CMAKE_CURRENT_BINARY_DIR}/sieve-vacation.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KPim6/KSieveCore/ksievecore
    COMPONENT Devel
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libksievecore_version.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KPim6/KSieveCore COMPONENT Devel
    )


set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KPim6KSieveCore")
if(BUILD_QCH)
    ecm_add_qch(
        KPim6KSieveCore_QCH
        NAME KPim6KSieveCore
        BASE_NAME KPim6KSieveCore
        VERSION ${PIM_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
        ${ksievecore_imapinstance_HEADERS}
        ${ksievecore_managescriptsjob_HEADERS}
        ${ksievecore_util_HEADERS}
        ${ksievecore_scriptsparsing_HEADERS}
        ${ksievecore_vacation_HEADERS}
        LINK_QCHS
        Qt6Core_QCH
        INCLUDE_DIRS
        ${CMAKE_CURRENT_BINARY_DIR}
        BLANK_MACROS
        KSIEVECORE_EXPORT
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )
endif()



if(BUILD_QCH)
    ecm_install_qch_export(
        TARGETS KPim6KSieveCore_QCH
        FILE KPim6KSieveCoreQchTargets.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel
    )
set(PACKAGE_INCLUDE_QCHTARGETS "include(\"\${CMAKE_CURRENT_LIST_DIR}/KPim6KSieveCoreQchTargets.cmake\")")
endif()

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KPimKSieveCoreConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveCoreConfig.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveCoreConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveCoreConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT KPim6KSieveCoreTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KPim6KSieveCoreTargets.cmake NAMESPACE KPim6::)

=== src/ksieveui/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause

ecm_setup_version(PROJECT VARIABLE_PREFIX LIBKSIEVEUI
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/libksieveui_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KPim6KSieveUiConfigVersion.cmake"
                        SOVERSION 6
)

add_library(KPim6KSieveUi)
add_library(KPim6::KSieveUi ALIAS KPim6KSieveUi)
if(KDEPIM_ENTERPRISE_BUILD)
    set(USE_GRAPHICAL_SIEVE_EDITOR true)
else()
    set(USE_GRAPHICAL_SIEVE_EDITOR false)
endif()


configure_file(settings/sieve-editor.kcfg.in ${CMAKE_CURRENT_BINARY_DIR}/sieve-editor.kcfg)

if(BUILD_TESTING)
    add_subdirectory(editor/tests)
    add_subdirectory(editor/autotests)
    add_subdirectory(autocreatescripts/tests)
    add_subdirectory(vacation/autotests)
    add_subdirectory(scriptsparsing/tests)
    add_subdirectory(sievescriptdebugger/autotests)
    add_subdirectory(sievescriptdebugger/tests)
    add_subdirectory(autocreatescripts/autotests/)
    add_subdirectory(editor/webengine/findbar/autotests/)
    add_subdirectory(editor/webengine/autotests/)
    add_subdirectory(widgets/autotests)
endif()

target_sources(KPim6KSieveUi PRIVATE
    vacation/vacationmaillineedit.cpp
    vacation/vacationeditwidget.cpp
    vacation/multiimapvacationdialog.cpp
    vacation/vacationpagewidget.cpp
    vacation/vacationwarningwidget.cpp
    vacation/vacationmanager.cpp
    vacation/vacationmailactionwidget.cpp
)
target_sources(KPim6KSieveUi PRIVATE
    editor/webengine/sieveeditorwebengineview.cpp
    editor/webengine/sieveeditorhelphtmlwidget.cpp
    editor/webengine/sieveeditorloadprogressindicator.cpp
    editor/webengine/findbar/findbarbase.cpp
    editor/webengine/findbar/findbarwebengineview.cpp
)

target_sources(KPim6KSieveUi PRIVATE
    editor/sieveeditorwidget.cpp
    editor/sievetextedit.cpp
    editor/sieveeditor.cpp
    editor/sievelinenumberarea.cpp
    editor/sieveinfowidget.cpp
    editor/sieveeditortextmodewidget.cpp
    editor/sieveeditorabstractwidget.cpp
    editor/warningwidget/sieveeditorwarning.cpp
    editor/warningwidget/sieveeditorparsingmissingfeaturewarning.cpp
    editor/sieveeditortabwidget.cpp
    editor/sieveeditorutil.cpp
    editor/sieveeditormenubar.cpp
    editor/sievetexteditorspellcheckdecorator.cpp
    editor/sievetexteditwidget.cpp
    editor/sieveinfodialog.cpp
    editor/sievepurposemenuwidget.cpp
    editor/sievepurposemenuwidget.h
)

target_sources(KPim6KSieveUi PRIVATE
    autocreatescripts/sievepreviewgeneratedcodewidget.cpp
    autocreatescripts/sieveeditorgraphicalmodewidgetabstract.cpp
    autocreatescripts/sievescriptparsingerrordialog.cpp
    autocreatescripts/sieveeditorgraphicalmodewidget.cpp
    autocreatescripts/autocreatescriptdialog.cpp
    autocreatescripts/sieveconditionwidgetlister.cpp
    autocreatescripts/sievescriptlistbox.cpp
    autocreatescripts/sievescriptdescriptiondialog.cpp
    autocreatescripts/sieveactionwidgetlister.cpp
    autocreatescripts/sievescriptpage.cpp
    autocreatescripts/sievescriptblockwidget.cpp
    autocreatescripts/sievescripttabwidget.cpp
    autocreatescripts/autocreatescriptutil.cpp
    autocreatescripts/sieveincludewidget.cpp
    autocreatescripts/sieveforeverypartwidget.cpp
    autocreatescripts/sievewidgetpageabstract.cpp
    autocreatescripts/sieveglobalvariablewidget.cpp
    autocreatescripts/sieveactions/sieveactionlist.cpp
    autocreatescripts/sieveactions/sieveaction.cpp
    autocreatescripts/sieveactions/sieveactiondiscard.cpp
    autocreatescripts/sieveactions/sieveactionstop.cpp
    autocreatescripts/sieveactions/sieveactionsetflags.cpp
    autocreatescripts/sieveactions/sieveactionaddflags.cpp
    autocreatescripts/sieveactions/sieveactionfileinto.cpp
    autocreatescripts/sieveactions/sieveactionreject.cpp
    autocreatescripts/sieveactions/sieveactionkeep.cpp
    autocreatescripts/sieveactions/sieveactionredirect.cpp
    autocreatescripts/sieveactions/sieveactionabstractflags.cpp
    autocreatescripts/sieveactions/sieveactionremoveflags.cpp
    autocreatescripts/sieveactions/sieveactionnotify.cpp
    autocreatescripts/sieveactions/sieveactionabstracteditheader.cpp
    autocreatescripts/sieveactions/sieveactiondeleteheader.cpp
    autocreatescripts/sieveactions/sieveactionaddheader.cpp
    autocreatescripts/sieveactions/sieveactionvacation.cpp
    autocreatescripts/sieveactions/sieveactionenclose.cpp
    autocreatescripts/sieveactions/sieveactionreplace.cpp
    autocreatescripts/sieveactions/sieveactionextracttext.cpp
    autocreatescripts/sieveactions/sieveactionbreak.cpp
    autocreatescripts/sieveactions/sieveactionconvert.cpp
    autocreatescripts/sieveactions/sieveactionsetvariable.cpp
    autocreatescripts/sieveactions/sieveactionreturn.cpp
    autocreatescripts/sieveactions/sieveactionereject.cpp
    autocreatescripts/sieveactions/widgets/selectflagswidget.cpp
    autocreatescripts/sieveactions/widgets/addresslineedit.cpp
    autocreatescripts/sieveactions/widgets/selectaddheaderpositioncombobox.cpp
    autocreatescripts/sieveactions/widgets/selectimportancecombobox.cpp
    autocreatescripts/sieveactions/widgets/multilineedit.cpp
    autocreatescripts/sieveactions/widgets/selectvacationcombobox.cpp
    autocreatescripts/sieveactions/widgets/selectvariablemodifiercombobox.cpp
    autocreatescripts/commonwidgets/selectconvertparameterwidget.cpp
    autocreatescripts/commonwidgets/selectmatchtypecombobox.cpp
    autocreatescripts/commonwidgets/selectmimetypecombobox.cpp
    autocreatescripts/commonwidgets/sievehelpbutton.cpp
    autocreatescripts/commonwidgets/sievecommonactioncondition.cpp
    autocreatescripts/sieveconditions/sievecondition.cpp
    autocreatescripts/sieveconditions/sieveconditionheader.cpp
    autocreatescripts/sieveconditions/sieveconditionlist.cpp
    autocreatescripts/sieveconditions/sieveconditionaddress.cpp
    autocreatescripts/sieveconditions/sieveconditionsize.cpp
    autocreatescripts/sieveconditions/sieveconditionenvelope.cpp
    autocreatescripts/sieveconditions/sieveconditionexists.cpp
    autocreatescripts/sieveconditions/sieveconditiontrue.cpp
    autocreatescripts/sieveconditions/sieveconditionbody.cpp
    autocreatescripts/sieveconditions/sieveconditiondate.cpp
    autocreatescripts/sieveconditions/sieveconditioncurrentdate.cpp
    autocreatescripts/sieveconditions/sieveconditionmailboxexists.cpp
    autocreatescripts/sieveconditions/sieveconditionspamtest.cpp
    autocreatescripts/sieveconditions/sieveconditionvirustest.cpp
    autocreatescripts/sieveconditions/sieveconditionihave.cpp
    autocreatescripts/sieveconditions/sieveconditionfalse.cpp
    autocreatescripts/sieveconditions/sieveconditionenvironment.cpp
    autocreatescripts/sieveconditions/sieveconditionhasflag.cpp
    autocreatescripts/sieveconditions/sieveconditionmetadata.cpp
    autocreatescripts/sieveconditions/sieveconditionconvert.cpp
    autocreatescripts/sieveconditions/sieveconditionmetadataexists.cpp
    autocreatescripts/sieveconditions/sieveconditionservermetadata.cpp
    autocreatescripts/sieveconditions/sieveconditionservermetadataexists.cpp
    autocreatescripts/sieveconditions/widgets/selectdatewidget.cpp
    autocreatescripts/sieveconditions/widgets/selectaddresspartcombobox.cpp
    autocreatescripts/sieveconditions/widgets/selectheadertypecombobox.cpp
    autocreatescripts/sieveconditions/widgets/selectbodytypewidget.cpp
    autocreatescripts/sieveconditions/widgets/selectrelationalmatchtype.cpp
    autocreatescripts/sieveconditions/widgets/selectcomparatorcombobox.cpp
    autocreatescripts/sieveconditions/widgets/selectmimecombobox.cpp
    autocreatescripts/sieveconditions/widgets/selectsizetypecombobox.cpp
    autocreatescripts/sieveconditions/widgets/selectsizewidget.cpp
    autocreatescripts/sieveconditions/widgets/sievedatespinbox.cpp
    autocreatescripts/sieveconditions/widgets/regexpeditorlineedit.cpp
)

target_sources(KPim6KSieveUi PRIVATE
    scriptsparsing/parsingresultdialog.cpp
)

target_sources(KPim6KSieveUi PRIVATE
    sievescriptdebugger/sievescriptdebuggerdialog.cpp
    sievescriptdebugger/sievescriptdebuggerwidget.cpp
    sievescriptdebugger/sievescriptdebuggerfrontendwidget.cpp
    sievescriptdebugger/sievescriptdebuggerwarning.cpp
    sievescriptdebugger/sievescriptdebuggertextedit.cpp
    sievescriptdebugger/sievescriptdebuggerresulteditor.cpp
)

target_sources(KPim6KSieveUi PRIVATE
    widgets/custommanagesievewidget.cpp
    widgets/sievetreewidgetitem.cpp
    widgets/managesievetreeview.cpp
    widgets/managesievewidget.cpp
    widgets/abstractmoveimapfolderwidget.cpp
    widgets/abstractregexpeditorlineedit.cpp
    widgets/abstractselectemaillineedit.cpp
    widgets/lineeditvalidator.cpp
    widgets/includefilelineedit.cpp
    widgets/moveimapfolderwidget.cpp
)

target_sources(KPim6KSieveUi PRIVATE
    managesievescriptsdialog.cpp
    debug/sievedebugdialog.cpp
    templates/sievetemplatewidget.cpp
    templates/sievedefaulttemplate.cpp
    templates/sievetemplateeditdialog.cpp
    editor/sieveeditortabwidget.h
    editor/sievetextedit.h
    editor/sievetexteditorspellcheckdecorator.h
    editor/sieveeditortextmodewidget.h
    editor/sievetexteditwidget.h
    editor/sieveinfowidget.h
    editor/sieveinfodialog.h
    editor/sieveeditor.h
    editor/sieveeditorabstractwidget.h
    editor/webengine/findbar/findbarwebengineview.h
    editor/webengine/findbar/findbarbase.h
    editor/webengine/sieveeditorloadprogressindicator.h
    editor/webengine/sieveeditorhelphtmlwidget.h
    editor/webengine/sieveeditorwebengineview.h
    editor/sieveeditorwidget.h
    editor/sieveeditorutil.h
    editor/sieveeditormenubar.h
    editor/warningwidget/sieveeditorwarning.h
    editor/warningwidget/sieveeditorparsingmissingfeaturewarning.h
    editor/sievelinenumberarea.h
    templates/sievedefaulttemplate.h
    templates/sievetemplatewidget.h
    templates/sievetemplateeditdialog.h
    scriptsparsing/parsingresultdialog.h
    ksieveui_private_export.h
    widgets/lineeditvalidator.h
    widgets/sievetreewidgetitem.h
    widgets/custommanagesievewidget.h
    widgets/moveimapfolderwidget.h
    widgets/managesievetreeview.h
    widgets/managesievewidget.h
    widgets/abstractregexpeditorlineedit.h
    widgets/abstractselectemaillineedit.h
    widgets/abstractmoveimapfolderwidget.h
    widgets/includefilelineedit.h
    vacation/vacationwarningwidget.h
    vacation/vacationmailactionwidget.h
    vacation/multiimapvacationdialog.h
    vacation/vacationmaillineedit.h
    vacation/vacationmanager.h
    vacation/vacationpagewidget.h
    vacation/vacationeditwidget.h
    autocreatescripts/sieveforeverypartwidget.h
    autocreatescripts/sievepreviewgeneratedcodewidget.h
    autocreatescripts/sievescriptdescriptiondialog.h
    autocreatescripts/sieveeditorgraphicalmodewidget.h
    autocreatescripts/sieveactionwidgetlister.h
    autocreatescripts/sievescriptlistbox.h
    autocreatescripts/sieveconditions/sieveconditionmetadata.h
    autocreatescripts/sieveconditions/sieveconditionsize.h
    autocreatescripts/sieveconditions/sieveconditionaddress.h
    autocreatescripts/sieveconditions/sieveconditionihave.h
    autocreatescripts/sieveconditions/sieveconditionenvelope.h
    autocreatescripts/sieveconditions/sieveconditiondate.h
    autocreatescripts/sieveconditions/sieveconditionmetadataexists.h
    autocreatescripts/sieveconditions/sieveconditionlist.h
    autocreatescripts/sieveconditions/sieveconditiontrue.h
    autocreatescripts/sieveconditions/sieveconditioncurrentdate.h
    autocreatescripts/sieveconditions/sieveconditionexists.h
    autocreatescripts/sieveconditions/sieveconditionmailboxexists.h
    autocreatescripts/sieveconditions/sieveconditionfalse.h
    autocreatescripts/sieveconditions/widgets/selectmimecombobox.h
    autocreatescripts/sieveconditions/widgets/selectbodytypewidget.h
    autocreatescripts/sieveconditions/widgets/selectsizetypecombobox.h

=== src/ksievecore/scriptsparsing/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
# Create the directory that will contain the generated xml files
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/data")

macro(add_sieveeditor_xmlprintingscriptbuilding _source)
    get_filename_component(_name ${_source} NAME_WE)
    set(_test ${_source} ${_name}.h)
    ecm_add_test(${_test}
        TEST_NAME ${_name}
        NAME_PREFIX "sieveeditor-xmlprintingscriptbuilding-"
        LINK_LIBRARIES Qt::Test KF6::I18n KPim6KSieveCore
        )
    target_compile_definitions(${_name} PRIVATE XMLPRINTINGSCRIPTBUILDER_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data")
    target_compile_definitions(${_name} PRIVATE XMLPRINTINGSCRIPTBUILDER_GENERATED_DATA_DIR="${CMAKE_CURRENT_BINARY_DIR}/data")
endmacro()

add_sieveeditor_xmlprintingscriptbuilding(xmlprintingscriptbuildertest.cpp)

=== src/ksievecore/sieveimapinstance/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

macro(add_sieveimapinstance_test _source)
  set(_test ${_source})
  get_filename_component( _name ${_source} NAME_WE )
  add_executable(${_name} ${_test} ${_name}.h)
  add_test(NAME ${_name} COMMAND ${_name})
  ecm_mark_as_test(sieveimapinstancetest-${_name})
  target_link_libraries(${_name}  KPim6KSieveCore Qt::Test)
endmacro()


add_sieveimapinstance_test(sieveimapinstancetest.cpp)
add_sieveimapinstance_test(sieveimapinstanceinterfacemanagertest.cpp)

=== src/ksievecore/util/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
macro(add_sieveutil_test _source _additionalsource)
  set(_test ${_source} ${_additionalsource})
  get_filename_component(_name ${_source} NAME_WE)
  add_executable(${_name} ${_test} ${_name}.h)
  add_test(NAME ${_name} COMMAND ${_name})
  ecm_mark_as_test(sievescriptdebugger-${_name})
  target_link_libraries(${_name}  KPim6KSieveCore Qt::Test KPim6::MailTransport KF6::I18n)
endmacro()

add_sieveutil_test(sieveaccounttest.cpp "")
add_sieveutil_test(findaccountinfojobtest.cpp "akonadiimapsettinginterfacetest.cpp")
add_sieveutil_test(regexpconvertertest.cpp "")

=== src/ksievecore/vacation/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

macro(add_ksievecore_vacation_test _source)
    set( _test ${_source} )
    add_definitions(-DVACATIONTESTDATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data/")
    get_filename_component( _name ${_source} NAME_WE )
    add_executable(${_name} ${_test} ${_name}.h)
    add_test(NAME ${_name} COMMAND ${_name})
    ecm_mark_as_test(vacation-${_name})
    target_link_libraries(${_name}  KPim6KSieveCore Qt::Test KF6::I18n KPim6::Mime)
endmacro()

add_ksievecore_vacation_test(vacationutilstest.cpp)

=== src/ksieveui/autocreatescripts/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause

add_executable(autocreatescripts_gui autocreatescripts_gui.cpp ../../tests/capability.cpp)
target_include_directories(autocreatescripts_gui PRIVATE ${libksieve_SOURCE_DIR}/src/ksieveui/scriptsparsing)
target_link_libraries(autocreatescripts_gui
  KPim6KSieveUi
  KPim6KSieveCore
  KPim6::PimCommon
  KF6::I18n
)

####
add_executable(parsingscript_gui parsingscript_gui.cpp ../../tests/capability.cpp)
target_include_directories(parsingscript_gui PRIVATE ${libksieve_SOURCE_DIR}/src/ksieveui/scriptsparsing)
target_link_libraries(parsingscript_gui
  KPim6KSieveUi
  KPim6KSieveCore
  KPim6::KSieve
  KPim6::PimCommon
  KF6::I18n
  KF6::SyntaxHighlighting
)

=== src/ksieveui/editor/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause

include_directories(${libksieve_SOURCE_DIR}
        ${libksieve_SOURCE_DIR}/src/ksieveui/scriptsparsing
        )


set(editorsieve_gui_SRCS editorsieve_gui.cpp ../../tests/capability.cpp editorsieve_gui.h ../../tests/capability.h)
add_executable(editorsieve_gui ${editorsieve_gui_SRCS})
target_link_libraries(editorsieve_gui
  KPim6KSieveUi
  KPim6::PimCommon
  KF6::I18n
  Qt::PrintSupport
  KF6::SyntaxHighlighting
)

=== src/ksieveui/scriptsparsing/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
include_directories(${libksieveui_SOURCE_DIR}
        ${libksieve_SOURCE_DIR}/src/ksieveui
        ${libksieve_SOURCE_DIR}/src/ksieveui/scriptsparsing/
        )

add_executable(xmlsieveparsing  main.cpp)
target_link_libraries(xmlsieveparsing  KPim6KSieveCore KPim6KSieveUi KPim6::KSieve KF6::I18n KF6::SyntaxHighlighting)

=== debian/changelog ===
libksieve (4:24.12.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (24.12.3).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.7.2 (No changes needed).

 -- Patrick Franz <deltaone@debian.org>  Sat, 29 Mar 2025 18:50:06 +0100

=== debian/control ===
Source: libksieve
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>, Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.6.0~),
               gettext,
               libkdepim-dev (>= 4:24.12.3~),
               libkf6archive-dev (>= 6.6.0~),
               libkf6colorscheme-dev (>= 6.6.0~),
               libkf6coreaddons-dev (>= 6.6.0~),
               libkf6doctools-dev (>= 6.6.0~),
               libkf6i18n-dev (>= 6.6.0~),
               libkf6iconthemes-dev (>= 6.6.0~),
               libkf6kio-dev (>= 6.6.0~),
               libkf6newstuff-dev (>= 6.6.0~),
               libkf6sonnet-dev (>= 6.6.0~),
               libkf6syntaxhighlighting-dev (>= 6.6.0~),
               libkidentitymanagement-dev (>= 24.12.3~),
               libkimap-dev (>= 24.12.3~),
               libkmailtransport-dev (>= 24.12.3~),
               libkmime-dev (>= 24.12.3~),
               libktextaddons-dev (>= 1.5.4~),
               libpimcommon-dev (>= 4:24.12.3~),
               libsasl2-dev,
               qt6-base-dev (>= 6.7.0~),
               qt6-webengine-dev (>= 6.7.0~),
               xauth,
               xvfb,
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/pim/libksieve
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/libksieve
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/libksieve.git
Rules-Requires-Root: no

Package: libksieve-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Breaks: libkf5ksieve-data,
Replaces: libkf5ksieve-data,
Description: Sieve mail filtering language support for kdepim, data files
 This library implements a parser and lexer for Sieve, the mail filtering
 language (RFC 3028).
 .
 This package is part of the KDE PIM module.
 .
 This package provides the data files common to the kf5ksieve libraries.

Package: libksieve-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libkf6syntaxhighlighting-dev (>= 6.6.0~),
         libkpim6kmanagesieve6 (= ${binary:Version}),
         libkpim6ksieve6 (= ${binary:Version}),
         libkpim6ksievecore6 (= ${binary:Version}),
         libkpim6ksieveui6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Sieve mail filtering language support for kdepim, development files
 This library implements a parser and lexer for Sieve, the mail filtering
 language (RFC 3028).
 .
 This package contains development files for ksieve.

Package: libkpim6kmanagesieve6
Provides: ${ABI:VirtualPackage},
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libksieve-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Sieve remote script management support for kdepim, library
 This library implements a subset of the protocol for remotely managing Sieve
 scripts (RFC 5804). Among other basic operations, it provides an easy to use
 API for listing, retrieving, deleting, activating and uploading of scripts to
 the remote Sieve script server.
 .
 This package is part of the KDE PIM module.

Package: libkpim6ksieve6
Provides: ${ABI:VirtualPackage},
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libksieve-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Sieve mail filtering language support for kdepim, library
 This library implements a parser and lexer for Sieve, the mail filtering
 language (RFC 3028).
 .
 This package is part of the KDE PIM module.

Package: libkpim6ksievecore6
Provides: ${ABI:VirtualPackage},
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libksieve-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Sieve mail filtering language support for kdepim, core library
 This library implements the core services for libksieve.
 .
 This package is part of the KDE PIM module.

Package: libkpim6ksieveui6
Provides: ${ABI:VirtualPackage},
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libksieve-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Sieve mail filtering language support for kdepim, GUI library
 This library implements GUI dialogs and elements which enable users to easily
 create, edit and manage their mail filters on the mail servers which support
 the Sieve language (RFC 3028) and the protocol for remotely managing Sieve
 scripts (RFC 5804).
 .
 This package is part of the KDE PIM module.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/release-service/([\d.]+)/src/libksieve-([\d.]+)\.tar\.xz

## libksieve 25.04.0

=== src/ksieveui/sievescriptdebugger/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2025 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
add_executable(sievescriptdebugger_gui sievescriptdebugger_gui.cpp)

target_link_libraries(sievescriptdebugger_gui
  KPim6::KSieve
  KPim6KSieveUi
  KF6::I18n
)

## libksieve 25.07.80

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2025 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
set(PIM_VERSION "6.4.80")

project(libksieve VERSION ${PIM_VERSION})

set(KF_MIN_VERSION "6.14.0")
set(QT_REQUIRED_VERSION "6.8.0")
set(CMAKE_CXX_STANDARD 20)
find_package(ECM ${KF_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(GenerateExportHeader)
include(ECMGenerateHeaders)

include(ECMSetupVersion)
file(
    GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES
    src/*.cpp
    src/*.h
    autotests/*.cpp
    autotests/*.h
)
set(PRE_COMMIT_INSTALLED FALSE)
if(${CMAKE_SOURCE_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    if(EXISTS "${PROJECT_SOURCE_DIR}/.git/hooks/pre-commit")
        file(READ "${PROJECT_SOURCE_DIR}/.git/hooks/pre-commit" FILE_CONTENTS)
        string(FIND "${FILE_CONTENTS}" "File generated by pre-commit" INDEX)
        if(${INDEX} GREATER_EQUAL 0)
            set(PRE_COMMIT_INSTALLED TRUE)
        endif()
    endif()
endif()
if(NOT ${PRE_COMMIT_INSTALLED})
    include(KDEGitCommitHooks)
    include(KDEClangFormat)
    kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
endif()
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(ECMFeatureSummary)
include(ECMAddTests)
include(ECMAddQch)
include(ECMCheckOutboundLicense)
file(
    GLOB_RECURSE ALL_SOURCE_FILES
    src/*.cpp
    src/*.h
    autotests/*.cpp
    autotests/*.h
)
ecm_check_outbound_license(LICENSES GPL-2.0-only  FILES ${ALL_SOURCE_FILES})

set(KTEXTADDONS_MIN_VERSION "1.6.0")
# Remove it when next 1.6.0 KTEXTADDONS_MIN_VERSION
set(KTEXTADDONS_WITH_TEXTAUTOGENERATETEXT_VERSION "1.6.0")

option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(
    QCH
    ${BUILD_QCH}
    "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)"
)

set(LIBKSIEVE_LIB_VERSION ${PIM_VERSION})
set(KMIME_LIB_VERSION "6.4.80")
set(IDENTITYMANAGEMENT_LIB_VERSION "6.4.80")
set(KMAILTRANSPORT_LIB_VERSION "6.4.80")
set(KPIMTEXTEDIT_LIB_VERSION "6.4.80")
set(LIBKDEPIM_LIB_VERSION "6.4.80")
set(PIMCOMMON_LIB_VERSION "6.4.80")
set(KIMAP_LIB_VERSION "6.4.80")

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if(USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
endif()
add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
option(
    KDEPIM_ENTERPRISE_BUILD
    "Enable features specific to the enterprise branch, which are normally disabled. Also, it disables many components not needed for Kontact such as the Kolab client."
    FALSE
)
# Look for Sasl2 before anything else
find_package(Sasl2)
set_package_properties(
    Sasl2
    PROPERTIES
        TYPE
            REQUIRED
)

find_package(
    Qt6
    ${QT_REQUIRED_VERSION}
    CONFIG
    REQUIRED
        Widgets
        PrintSupport
        WebEngineWidgets
)
find_package(KF6I18n ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6ColorScheme ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6KIO ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6CoreAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6IconThemes ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KPim6PimCommon ${PIMCOMMON_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6Libkdepim ${LIBKDEPIM_LIB_VERSION} CONFIG REQUIRED)
find_package(KF6NewStuff ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Archive ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6SyntaxHighlighting ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Sonnet ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KPim6Mime ${KMIME_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6IdentityManagementCore ${IDENTITYMANAGEMENT_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MailTransport ${KMAILTRANSPORT_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6IMAP ${KIMAP_LIB_VERSION} CONFIG REQUIRED)

find_package(KF6TextEditTextToSpeech ${KTEXTADDONS_MIN_VERSION} CONFIG)
if(TARGET KF6::TextEditTextToSpeech)
    add_definitions(-DHAVE_KTEXTADDONS_TEXT_TO_SPEECH_SUPPORT)
endif()
find_package(KF6TextCustomEditor ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6TextAddonsWidgets ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6TextUtils ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6DocTools ${KF_MIN_VERSION})
set_package_properties(
    KF6DocTools
    PROPERTIES
        DESCRIPTION
            "Tools to generate documentation"
        TYPE
            OPTIONAL
)
option(OPTION_ADD_AUTOGENERATETEXT "Add support for autogenerate text plugin" ON)
if(OPTION_ADD_AUTOGENERATETEXT)
    find_package(KF6TextAutoGenerateText ${KTEXTADDONS_WITH_TEXTAUTOGENERATETEXT_VERSION} CONFIG)
    set_package_properties(
        KF6TextAutoGenerateText
        PROPERTIES
            TYPE
                OPTIONAL
            PURPOSE
                "Required for building AI plugins support"
            DESCRIPTION
                "Use AI plugin"
    )
endif()

if(TARGET KF6::TextAutoGenerateText)
    set(HAVE_TEXT_AUTOGENERATE_TEXT TRUE)
endif()

########### Targets ###########
ecm_set_disabled_deprecation_versions(QT 6.10.0 KF 6.16.0)

if(BUILD_TESTING)
    add_definitions(-DBUILD_TESTING)
endif()
########### CMake Config Files ###########
if(BUILD_TESTING)
    find_package(Qt6 ${QT_REQUIRED_VERSION} CONFIG REQUIRED COMPONENTS Test)
    add_subdirectory(autotests)
endif()

add_subdirectory(src)

ecm_qt_install_logging_categories(
        EXPORT LIBKSIEVE
        FILE libksieve.categories
        DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

if(DEFINED kde_configure_git_pre_commit_hook)
    kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
endif()
ki18n_install(po)
if(KF6DocTools_FOUND)
    kdoctools_install(po)
endif()

ecm_feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== debian/changelog ===
libksieve (4:25.07.80-0ubuntu1) questing; urgency=medium

  * New upstream (beta) release (25.07.80)

 -- Rik Mills <rikmills@kde.org>  Mon, 14 Jul 2025 06:44:51 +0100

libksieve (4:25.04.3-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Jul 2025 07:55:25 +0100

libksieve (4:25.04.2-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jun 2025 12:00:30 +0100

libksieve (4:25.04.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 07 May 2025 22:17:31 +0100

libksieve (4:25.04.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.0)

 -- Rik Mills <rikmills@kde.org>  Wed, 30 Apr 2025 20:02:40 +0100

libksieve (4:24.12.3-0ubuntu1) plucky; urgency=medium

  * New upstream release.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 15 Mar 2025 14:15:31 -0500

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: libksieve
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>, Patrick Franz <deltaone@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
-               cmake (>= 3.16~),
                extra-cmake-modules (>= 6.6.0~),
                gettext,
-               libkdepim-dev (>= 4:24.12.3~),
+               libkdepim-dev (>= 4:25.07.80~),
                libkf6archive-dev (>= 6.6.0~),
                libkf6colorscheme-dev (>= 6.6.0~),
                libkf6coreaddons-dev (>= 6.6.0~),
@@ -19,21 +20,21 @@
                libkf6newstuff-dev (>= 6.6.0~),
                libkf6sonnet-dev (>= 6.6.0~),
                libkf6syntaxhighlighting-dev (>= 6.6.0~),
-               libkidentitymanagement-dev (>= 24.12.3~),
-               libkimap-dev (>= 24.12.3~),
-               libkmailtransport-dev (>= 24.12.3~),
-               libkmime-dev (>= 24.12.3~),
+               libkidentitymanagement-dev (>= 25.07.80~),
+               libkimap-dev (>= 25.07.80~),
+               libkmailtransport-dev (>= 25.07.80~),
+               libkmime-dev (>= 25.07.80~),
                libktextaddons-dev (>= 1.5.4~),
-               libpimcommon-dev (>= 4:24.12.3~),
+               libpimcommon-dev (>= 4:25.07.80~),
                libsasl2-dev,
                qt6-base-dev (>= 6.7.0~),
                qt6-webengine-dev (>= 6.7.0~),
                xauth,
                xvfb,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
 Homepage: https://invent.kde.org/pim/libksieve
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/libksieve
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/libksieve.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libksieve
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libksieve
 Rules-Requires-Root: no
 
 Package: libksieve-data
